; 90.orc -- generate impulse response for 90 degree phase shift
; written by Istvan Varga, Apr 2002

; read parameters from external include file
; the following macros should be defined:
;   SRATE:     sample rate in Hz
;   IR_LENGTH: total length of impulse response (in samples)
;   FL_START:  start location in impulse response (in samples)
;   FL_LENGTH: length of output file (in samples, should be power of two)

#include "/tmp/__90_ir_params_.orc"

sr	=  $SRATE
ksmps	=  1
nchnls	=  1

giflen	=  $IR_LENGTH
; create empty table
itmp	ftgen 1, 0, 16384, -2, 0

icnt	=  1		; only odd samples are used
l1:
; (-2/PI) / x function for phase shift
i1	=  -2 / (3.14159265 * (icnt - giflen * 0.5))
; window function
i2	=  cos(3.14159265 * (icnt - giflen * 0.5) / giflen)
i2	=  i2 * (i2 + 1) * 0.5
; write to table
	tableiw i1 * i2, icnt, 1
; next odd sample
icnt	=  icnt + 2
	if (icnt < (giflen - 0.5)) igoto l1

	instr 1

; set file length
p3	=  ($FL_LENGTH + 0.25) / sr
; read position
kfpos	init $FL_START
; read from table
k1	table int(kfpos + 0.5), 1
a1	=  k1
; next sample
kfpos	=  kfpos + 1
; write to output
	out a1

	endin

