#!/bin/bash

# installation script

if [ "${SADIR}" != "" ] ; then		# install directory
	INSTDIR="${SADIR}" ;
else
	INSTDIR="/Csound/Analysis" ;
fi

if ( ! ( test -d "${INSTDIR}" ) ) ; then
	if ( test -e "${INSTDIR}" ) ; then
		echo -e "${INSTDIR}: not a directory" ; exit -1 ;
	fi
	mkdir -p "${INSTDIR}" ; chmod 755 "${INSTDIR}" ;
fi

# render impulse responses

"./gen_cv.sh"

# copy to install directory

for i in `seq 1980 1 1991` ; do

	SRC="./convolve.${i}" ; DST="${INSTDIR}/convolve.${i}"
	rm -f "${DST}"					# remove old file
	cp -af "${SRC}" "${DST}"			# install new version
	chown 0:0 "${DST}" 2> /dev/null			# set permissions
	chmod 444 "${DST}"
	if ( ! ( diff "${SRC}" "${DST}" > /dev/null 2>&1 ) ) ; then
		echo -e "Error copying convolve.${i}" ; exit -1 ;
	fi ;
done

# delete temporary files

rm -f *.sf *.cv convolve.* *.srt

